;;;listing 2
(defun C:PARTS ( / DH PICK)
	(if PARTS_LIST
		(progn
			(setq DH (load_dialog 
				"CDNC2-93"))
			(if (new_dialog "MY_SLIDES" DH)
				(progn
					(setq PICK 0)
					(make_images PICK)
					(set_tile "IMG" "1")
					(set_tile "IMGN" (car 
						PARTS_LIST))
					(set_tile "IMGS" "1")
					(action_tile "IMG"
						"(part_number $value
						$reason)")
					(action_tile "IMGN" 
						"(part_name $value
						$reason)")
					(action_tile "IMGS" 
						"(part_slide $value
						$reason)")
					(action_tile "SLD1" 
						"(done_dialog 10)")
					(action_tile "SLD2" 
						"(done_dialog 11)")
					(action_tile "SLD3" 
						"(done_dialog 12)")
					(action_tile "SLD4" 
						"(done_dialog 13)")
					(set_tile "MESSAGE" (strcat 
						"Part list has "
						(itoa (length 
						PARTS_LIST))
						" members."))
					(setq TMP (start_dialog))
					(cond
						((= TMP 1) ;; ok picked, 
							used PICK value.
							(setq PICK (nth PICK 
								PARTS_LIST))
						)
						((> TMP 9) ;; icon picked
							(setq PICK (nth (+ PICK 
								(- TMP 10)) PARTS_LIST))
						)
						(t (setq PICK nil))
					)
					(if (and PICK
							(or (tblsearch
								"BLOCK" PICK)
								(findfile (strcat
									PICK ".dwg"))))
						(command "_INSERT" PICK 
							PAUSE 1 1 0)
						(prompt "\nParts cancelled")
					)
			))
	))
	(princ)
)
;;;listing 3
(defun MAKE_IMAGES (PICK / CNT X Y SLD SEL)
	(set_tile "MESSAGE" 
		(strcat "Selection is " 
			(itoa (1+ PICK))))
	(set_tile "IMG" (itoa (1+ PICK)))
	(set_tile "IMGN" 
		(nth PICK PARTS_LIST))
	(set_tile "IMGS" (itoa (1+ PICK)))
	(foreach SLD 
		(list "SLD1" "SLD2" "SLD3" "SLD4")
		(setq X 
			(dimx_tile SLD)
			Y (dimy_tile SLD))
		(start_image SLD)
		(if (< PICK (length PARTS_LIST))
			(progn
				(fill_image 0 0 X Y 0)
				(if (null SEL)
					(progn
						(fill_image 0 0 X Y 5)
						(setq SEL 'T)
				))
				(setq SLD
					(if SLIDE_LIB
						(strcat SLIDE_LIB "(" (nth 
							PICK PARTS_LIST) ")")
						(nth PICK PARTS_LIST)
					)
				)
				(slide_image 0 0 X Y SLD)
			)
			(fill_image 0 0 X Y 1)
		)
		(end_image)
		(setq PICK (1+ PICK))
	)
)
;;;Listing 4
(defun PART_NUMBER (VAL RES)
	(if (= RES 1)
		(progn
			(setq VAL (atoi VAL))
			(if (and (> VAL 0)
					(<= VAL (length PARTS_LIST)))
				(progn
					(setq PICK (1- VAL))
					(make_images PICK)
				)
				(set_tile "MESSAGE" "Input part number not accepted")
			)
		))
)
;;;Listing 5
(defun PART_NAME (VAL RES)
	(if (= RES 1)
		(progn
			(if (member (strcase VAL)
				PARTS_LIST)
				(progn
					(setq PICK (- (length
						PARTS_LIST) 
							(length (member
									(strcase VAL) 
									PARTS_LIST))))
					(make_images PICK)
				)
				(set_tile "MESSAGE" "Input
					name not in parts list")
			)
		)
	)
)
;;;Listing 6
(defun PART_SLIDE (VAL RES)
	(if (or (= RES 1) (= RES 3))
		(progn
			(set_tile "IMG" val)
			(set_tile "IMGN" (nth (1-
						(atoi val)) PARTS_LIST))
			(if (= RES 1)
				(progn
					(setq PICK (1- (atoi VAL)))
					(make_images PICK)
				)
				(set_tile "MESSAGE" 
					"Images updated when
					selection complete")
			)
		)
	)
)
;;;Listing 7
(setq PARTS_LIST
	(list
		"C2-93-A" "C2-93-B" "C2-93-C" 
		"C2-93-D" "C2-93-E" "C2-93-F"
		"C2-93-G" "C2-93-H" "C2-93-I" 
		"C2-93-J" "C2-93-K" "C2-93-L"
	)
)
(setq SLIDE_LIB nil)