;;;CADENCE, January, 1993; User Library, page 78-79
;;;By Rey Galura

;;;Listing 1.
(prompt "\nLoading WLEAD.LSP")
(defun L_LINE ()
 (setq pt1 (getpoint "\nEnter LEADER location: ")
       pt2 (getpoint pt1 "\nTo point or RETURN when done: "))
 (command "Dim" "Leader" pt1 pt2)
 (while
  (setq pt2 (getpoint pt2 "\nTo point or RETURN when done: "))
  (command pt2))
 (command)(command))
;This routine is used twice. When MK = "DO XY COUNT" it counts the max substring length to
;find the maximum line length  X & number of lines Y. The X & Y values are to be use to
;calulate the text position if the total text string is more than 18 chrs. When MK = "DO
; WORDWRAP" it does the actual wordwrap & outputs to the drawing.
(defun W_RA ()
 (setq n 0 stpt 1)
 (while (< n tsl)                   ;loop if n is greater than tsl
  (setq ltn n                       ;previous end of substring
        n (+ stpt maxstr))          ;reset n = to start position + max chr per line
  (if (<= n tsl)                    ;if end of substring is less than total string length
   (while                           ;loop search
    (/= (substr tmp_st n 1) " ")    ;search for blank space
    (setq n (1- n))))               ;decrement n 1 chr per loop
  (if (= mk "DO XY COUNT")          ;find max length X & no.  of rows Y
   (progn
    (substr tmp_st stpt (- n stpt))  ;do the substring
    (setq ycny (1+ ycny)             ;count number of loops for y
          tyspc (1- ycny))           ;reset ycny = to tyspc
    (if (> n tsl)                    ;if n is greater than tsl
     (setq mx2 (- tsl ltn))          ;last text string
     (setq mx2 (- n stpt)))          ;else
    (if (= mx1 0)                    ;if mx1 =0
     (setq mx1 (1- n)))              ;mx1 = end of substring - 1 character
    (setq txspc (max mx1 mx2)        ;max string length per loop
          mx1 txspc))                ;save max string lenth = mx1
   (progn                            ;mk=do wordwrap
    (command "Text" "ML" T1 TSIZ "0.0"
 (substr tmp_st stpt (- n stpt)))    ;do text
    (setq t1 (list (car t1)          ;reset X text coordinate
                   (- (cadr t1) SPC)))))
  (setq stpt (1+ n)))                ;reset start position
) ;end of defun W_RA
(defun C:WL ()
 (if (not tmp_st)(setq tmp_st "COMPUTER AIDED DRAFTING (CAD)"))
 (setq bmd (getvar "BLIPMODE") mk NIL
       txspc 0     ycny 0      mx1 0
       mx2 0       ltn 0       ds (getvar "dimscale")
       tsiz (* (getvar "dimtxt") ds))
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 0)
 (if (= ds 0.0)(progn
   (princ "\n\tSorry if DIMSCALE = 0.0 program won't execute.")
   (princ " PROGRAM ABORTED.")
   (*error*)))
 (l_line)                                 ;subroutine to draw leader
 (prompt "\nWARNING: String over 132 characters will truncate.")
 (prompt "\nEnter STRING <")           ;prompt user
 (princ tmp_st)                           ;show default
 (setq #tmp_st (getstring t ">:\n"))      ;get new string or ENTER if ok
 (if (= #tmp_st "")                       ;if default string is accepted
  (setq #tmp_st tmp_st)                   ;reset tmp_st
  (setq tmp_st #tmp_st))                  ;or tmp_st = new text string
 (setq tsl (strlen tmp_st)                ;total string length of note
       maxstr 18                          ;max character output per line
       spc (* tsiz 1.7)                   ;text spacing between lines
       lp1 (getvar "LASTPOINT")           ;lastpoint of leader line
       lp2 (osnap lp1 "QUICK,MIDP"))      ;midpoint of last leader line
 (cond                                    ;cond if text string is only one line
  ((<= tsl 18)                            ;total string length is less or eq to 18 chr
   (if (< (car lp1) (car lp2))            ;if lp1 is less text is LEFT of leader
    (progn
     (setq t1 (polar lp1 PI tsiz))        ;text loc LEFT of leader
     (command "Text" "MR" t1 tsiz "0.0" tmp_st)) ;do text left
    (progn
     (setq t1 (polar lp1 0.0 tsiz))  ;text loc RIGHT of leader
     (command "Text" "ML" t1 tsiz "0.0" tmp_st)))) ;do text right
  ((> tsl 18)                             ;cond if text is more than one line
   (setq mk "DO XY COUNT")                ;reset mk to call (W_RA)
   (w_ra)                                 ;find max line length X & no. of rows Y
   (if (< (car lp1) (car lp2))            ;test text location for L or R
    (progn
     (setq t1 (list (- (car lp1) (* tsiz txspc)) ;X loc. of text (L)
                    (+ (cadr lp1) (* spc tyspc)))))
    (progn
     (setq t1 (list (+ (car lp1) tsiz)    ;X loc. of text (Right)
                    (cadr lp1)))))
   (setq mk "DO WORDWRAP")                ;reset mk to call (W_RA)
   (w_ra)                                 ;to do wordwrap & outputs to dwg
   (setq e_lst (entget (entlast))         ;entity list last text to finshed leader
         e_tx (cdr (assoc 1 e_lst))       ;extract text on the list
        e_slg (1+ (atof (itoa (strlen e_tx))));text string length +1
         e_txsp (cdr (assoc 11 e_lst))    ;text alinement point
         lp3 (list (+ (car e_txsp) (* tsiz e_slg)) ;additional line start
                   (cadr e_txsp)))
   (if(and (> (car lp2) (car lp1))(<= e_slg 17))
      ;if text is left & e_slg is less than or = to 17 chr
    (command "Line" lp3 lp1 ""))))       ;add line to finish leader
 (setvar "BLIPMODE" bmd)                 ;reset bipmode
 (setvar "CMDECHO" 1)                    ;reset echo
 (princ)                             ;surpress nil
)
(princ " Loaded.\nTo start type WL at command prompt.")
(princ)
